# -----------------------------------------------------------
# Copyright (c) 2018 Lenovo AI Platform. All Rights Reserved.
# -----------------------------------------------------------
""" util file for all inference. """

from __future__ import division

import os
from os.path import isdir, join, isfile, splitext


def get_img_files(files_dir):
  if not isdir(files_dir):
    raise ValueError("%s doesn't exist!" % str(files_dir))

  files = [f for f in os.listdir(files_dir) if isfile(join(files_dir, f))]
  return [join(files_dir, f) for f in files
          if splitext(f)[1].lower() in ['.jpg', '.png', '.bmp', '.jpeg']]

def output_to_file(contents, filename):
  if isinstance(contents, dict):
    with open(filename, 'w') as f:
      for k, v in contents.iteritems():
        f.write(k + '  ' + v + '\n')
  elif isinstance(contents, list):
      for v in contents:
        f.write(v + '\n')
    
