# -----------------------------------------------------------
# Copyright (c) 2018 Lenovo AI Platform. All Rights Reserved.
# -----------------------------------------------------------

'''
Example:
# Infer npy data type
python unet_vail.py --checkpoint_dir='/home/zhouzd2/train67' --output_dir=/home/zhouzd2/tmp --inferce_data_dir=/home/zhouzd2/letrain/applications/ehealth_unet/indata_all.txt
'''

import tensorflow as tf
import sys, os
parentdpath1 = os.path.dirname(os.path.abspath(__file__))
parentdpath = parentdpath1[:-14] + 'applications'
path_list = [parentdpath + '/ehealth_unet', parentdpath]
sys.path += path_list
print sys.path
from get_data import batch_generator
import unet
import numpy as np
from util import combine_img_prediction, save_image

tf.app.flags.DEFINE_string('checkpoint_dir', '/home/zhouzd2/train67','checkpoint dir')
tf.app.flags.DEFINE_string('output_dir', '/home/zhouzd2/tmp','output result dir')
tf.app.flags.DEFINE_string('inferce_data_dir', '/home/zhouzd2/letrain/applications/ehealth_unet/indata_all.txt','inferce data dir')

FLAGS = tf.app.flags.FLAGS

def main():
    ckpt_dir = FLAGS.checkpoint_dir
    batch_size = 1
    data_path = FLAGS.inferce_data_dir
    save_image_dir = FLAGS.output_dir
    image_set = open(data_path, 'r').read().splitlines()
    graph = tf.Graph().as_default()
    with graph:
        #load data
        batch_x, batch_y = batch_generator(batch_size, image_set)
        config = tf.ConfigProto()
        config.gpu_options.allow_growth = True
        with tf.Session(config=config) as sess:
            Input_channels = 1
            Nb_classes = 2

            net = unet.Unet(channels=Input_channels, n_class=Nb_classes, cost_kwargs=dict(class_weights=[1, 3]),
                            layers=5,
                            features_root=32)

            saver = tf.train.Saver()
            if os.path.exists(ckpt_dir):
                print("unet Restoring Variables from Checkpoint.")
                saver.restore(sess, tf.train.latest_checkpoint(ckpt_dir))
                #saver.restore(sess, ckpt_dir + '/model.ckpt-110000')
            else:
                print("unet Not able to find Checkpoint. Going to stop now...")
                iii = 0
                iii / 0
            for step in xrange(len(image_set) / batch_size):
                loss, prediction = sess.run([net.cost, net.predicter], feed_dict={ net.x: batch_x,
                                                                                   net.y_specific: batch_y,
                                                                                   net.keep_prob: 1.})
                pred_shape = prediction.shape

                print ("Verification error= {:.1f}%, loss= {:.4f}".format(error_rate(prediction, batch_y), loss))
                img = combine_img_prediction(batch_x, batch_y, np.argmax(prediction, axis=-1))
                save_image(img, "%s/%s.jpg" % (save_image_dir, 'num_%s_'%step))
            print ("************ inferce end ****************")


def error_rate(predictions, labels):
    """
    Return the error rate based on dense predictions and 1-hot labels.
    """
    return 100.0 - (
        100.0 *
        np.sum(np.argmax(predictions, 3) == labels) /
        (predictions.shape[0] * predictions.shape[1] * predictions.shape[2]))

if __name__ == '__main__':
    main()